;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; mIRC Status v1.4 by Sephiroth - QuakeNet - #cyberscripters
;;;;;;;;;;;;;;;;;;;;;;;;;;;
on *:load:{
  if ($version < 6.0) { echo $color(info) -ag *** You need mIRC v6.0 (or higher) for this addon. www.mirc.com | .unload -rs $script }
  else {
    if (!$exists($+(",$mircdir,msthemes\,"))) { .mkdir msthemes }
    standardtheme
    e *** Welcome to my mIRC Status Script v1.4
    e *** Type /mircstats [port] to start mIRCStats at the given port. If no port is set mIRCStats will use Port 80.
    e *** Type /mircstatsconfig to set your own Color theme for the stats Page.
    e *** Type /endstats to stop this script.
  }
}
on *:start:{
  if (!$hget(mircstats)) { .hmake mircstats }
  .hload mircstats $thm(standard.thm)
}
alias mircstats {
  endstats
  var %x = $portfree(80)
  if (%x) && (!$1) { e * Listening now on $ip at Port: 80 | socklisten mircstats 80 }
  elseif (!%x) && (!$1) { e * Port 80 is already in use. Use /mircstats <port> }
  elseif ($1) {
    if ($1 isnum 1-65535) { 
      if ($portfree($1)) { e * Listening now on $ip2 at Port: $1 | socklisten mircstats $1 } 
      else { e * Port $1 is already in use. Use /mircstats <port> }
    }
    else { e * $1 is an invalid Port. Use /mircstats <1-65535> }
  }
}
alias endstats { if ($sock(mircstats)) { e * mIRCStats closed. } | sockclose mircstats }
alias mircstatsconfig { dialog $+(-,$iif($dialog(ms.config),v,m)) ms.config ms.config }

on 1:socklisten:mircstats:{
  var %temp = $r(1,200000)
  sockaccept mircstats $+ %temp
}
on 1:sockread:mircstats*:{
  sockread %line
  tokenize 32 %line
  if ($1 == GET) {
    scid $activecid
    var %ticks = $ticks,%window = $active
    if ((s isincs $gettok($chan(%window).mode,1,32)) && ($html(HideSecret))) %window = Secret!
    if ((p isincs $gettok($chan(%window).mode,1,32)) && ($html(HidePrivat))) %window = Privat!
    if ((%window = status window) || ($left(%window,1) = @) || ($left(%window,1) = =)) { %window = nothing for interest ;) }
    if ($appstate == minimized) { %window = mIRC is minimized }
    elseif ($appstate == tray) { %window = mIRC is minimized to tray }
    s <html>
    s <head>
    s <meta name="generator" content="ev0l cows"><style type="text/css"><!--
    s body $chr(123) scrollbar-face-color: $html(Face-Color) $+ ; scrollbar-shadow-color: $html(Shadow-Color) $+ ; scrollbar-highlight-color: $html(Highlight-Color) $+ ; scrollbar-3dlight-color: $html(3D-Light-Color) $+ ; scrollbar-darkshadow-color: $html(DarkShadow-Color) $+ ; scrollbar-track-color: $html(Track-Color) $+ ; scrollbar-arrow-color: $html(Arrow-Color) $+ ; font-family: verdana, arial, helvetica, sans-serif; font-size: 11px; color: $html(NormalText) $+ ; $chr(125)
    s table $chr(123) font-size: 10px; color: $html(Normaltext) $+ ; background: $html(Background(Tables)) $+ ; $chr(125)
    s a $chr(123) color: $html(Hyperlinks) $+ ; text-decoration: none; font-weight: bold; $chr(125)
    s a:hover $chr(123) color: $html(Hyperlinks(Hovered)) $+ ; text-decoration: none; font-weight: bold; $chr(125)
    s .bold $chr(123) font-size: 10px; color: $html(Normaltext) $+ ; font-weight: bold; $chr(125)
    s .lightbold $chr(123) font-size: 10px; color: $html(ErrorMessages) $+ ; font-weight: bold; $chr(125)
    s .contentborder $chr(123) border-top: 1px solid $html(Border-Style(Tables)) $+ ; border-left: 1px solid $html(Border-Style(Tables)) $+ ; border-right: 1px solid $html(Border-Style(Tables)) $+ ; border-bottom: 1px solid $html(Border-Style(Tables)) $+ ; $chr(125)
    s --></style>
    s <title> mIRC Status v1.4 </title>
    s </head>
    s <body leftmargin="10" topmargin="10" bgcolor=" $+ $html(Background) $+ ">
    s <center>
    s <h1>mIRC Status v1.4</h1>
    s <table width="900" border="0" class="contentborder" cellpadding="0">
    s <tr><td><u>Network Name</u></td><td><u>Network Server</u></td><td><u>My Nick</u></td><td><u>Idletime</u></td><td><u>Away</u></td></tr>
    var %x = $scid(0),%y = 0
    while (%y < %x) { inc %y | scon %y | s <tr><td><a href="./?id= $+ %y $+ "> $+ $iif($network,$network,Unknown Network) $+ </a></td><td> $iif($server,<a href="irc:// $+ $server $+ /"> $+ $server $+ </a>,<div class="bold">Not connected!</div>) $+ </td><td> $+ $iif($me,$me,No nickname) $+ </td><td> $+ $unix.dur($idle) $+ </td><td> $+ $iif($away,Yes,No) $+ </td></tr> }
    s </table></center>
    if (/?id=* iswm $2) {
      tokenize 38 $right($2,-2)
      %y = $0
      while (%y) { 
        var %var = $gettok($($+($,%y),2),1,61),%value = $gettok($($+($,%y),2),2,61)
        if (%var == id && %value isnum 1- $+ $scon(0)) {
          scon %value
          s <p><center>
          s <h1><b> $+ $iif($server,<a href="irc:// $+ $server $+ /">) $+ $iif($network,$ifmatch,Unknown Netowork) $+ $iif($server,</a>) $+ </b></h1>
          s <table width="500" border="0" class="contentborder" align="center" cellpadding="0">
          s <tr><td align="right" width="35%">Fullname:</td><td width="5%"></td><td align="left"> $+ $strip($fullname) $+ </td></tr>
          s <tr><td align="right">E-Mail:</td><td></td><td align="left"><a href="mailto: $+ $strip($emailaddr) $+ " alt="Send me an E-Mail"> $+ $strip($emailaddr) $+ </td></tr>
          s <tr><td align="right">Connection ID:</td><td></td><td align="left"> $+ %value $+ / $+ $scon(0) $+ </td></tr>
          s <tr><td align="right">Channels:</td><td></td><td align="left"> $+ $chan(0) $+ / $+ $chn $+ </td> </tr>
          s <tr><td align="right">Queries:</td><td></td><td align="left"> $+ $query(0) $+ / $+ $qry $+ </td></tr>
          if ($active != status window) {
            var %cid = $cid
            var %scon = $scon(0)
            while (%scon) {
              scon %scon
              if ($cid == $window($active).cid) { s <tr><td align="right">Active Window:</td><td></td><td align="left"> $+ %window $iif(%window ischan,$chr(40) $+ $nick($active,0) $+ u/ $+ $nick($active,0,o) $+ o/ $+ $iif(% isin $prefix,$nick($active,0,h,o) $+ h/) $+ $nick($active,0,v,oh) $+ v/ $+ $nick($active,0,r) $+ r $+ $chr(41)) ( $+ $iif($network,$ifmatch,Unknown Network) $+ ) $+ </td></tr> }
              dec %scon
            }
            scid %cid
          }
          else { s <tr><td align="right">Active Window:</td><td></td><td align="left"> $+ %window $+ </td></tr> }
          if ($away) s <tr><td align="right">Away:</td><td></td><td align="left"> $+ $mirc2html($iif($awaymsg,$awaymsg,I'm not away!)) $+ </td></tr>
          s </table></div>
          s </center>
          if ($calc($chan(0) - $scrt - $prvt)) {
            s <p><center>
            s <table width="1000" border="0" class="contentborder" cellpadding="0">
            ;s <tr><td class="bold" align="center" colspan=" $+ $iif(% isin $prefix,7,6) $+ "> $+ $iif($server,$iif($network,$network,Unknown Network) ( $+ <a href="irc:// $+ $server $+ /"> $+ $server $+ </a> $+ ),<div class="bold">Not connected!</div>) $+ </td></tr>
            ;s <tr colspan=" $+ $iif(% isin $prefix,7,6) $+ "></tr>
            s <tr>
            s <td width="40%"><u>Channel Name</u></td><td width="20%"><u>Channel Modes</u></td>
            var %m = $iif(% isin $prefix,8%,10%)
            s <td width=" $+ %m $+ "><u>User</u></td><td width=" $+ %m $+ "><u>Op</u></td> 
            if (% isin $prefix) { s <td width="8%"><u>HalfOp</u></td> }
            s <td width=" $+ %m $+ "><u>Voice</u></td><td width=" $+ %m $+ "><u>Regular</u></td>
            s </tr>
            var %i = 0,%z = $chan(0),%c,%showchan 
            while (%i < %z) {
              inc %i
              %c = $chan(%i)
              %showchan = 1 
              if (s isincs $gettok($chan(%c).mode,1,32) && $html(HideSecret)) { %showchan = 0 }
              if (p isincs $gettok($chan(%c).mode,1,32) && $html(HidePrivat)) { %showchan = 0 }
              if (%showchan) {
                s <tr colspan=" $+ $iif(% isin $prefix,7,6) $+ "> 
                s <td width="40%"> $_prefix($me,%c) $+ $iif($server,<a href="irc:// $+ $server $+ / $+ $right(%c,-1) $+ "> $+ %c $+ </a>,%c) $+ </td>
                s <td width="20%"> $+ $gettok($chan(%c).mode,1,32) $+ </td>
                var %m = $iif(% isin $prefix,8%,10%)
                s <td width=" $+ %m $+ "> $+ $nick(%c,0) $+ </td><td width=" $+ %m $+ "> $+ $nick(%c,0,o) $+ </td> 
                if (% isin $prefix) { s <td width="8%"> $+ $nick(%c,0,h,o) $+ </td> }
                s <td width=" $+ %m $+ "> $+ $nick(%c,0,v,oh) $+ </td><td width=" $+ %m $+ "> $+ $nick(%c,0,r) $+ </td>
                s </tr>
              }
            }
            s </table>
          }
          if ($query(0)) {
            s <p><center>
            s <table width="1000" border="0" class="contentborder" cellpadding="0">
            s <tr colspan="4"></tr>
            s <tr>
            s <td width="15%"><u>Query with:</u></td><td width="30%"><u>Address</u></td><td width="40"><u>Comchan</u></td>
            s </tr>
            if ($query(0)) { 
              var %i = 0,%z = $query(0),%c
              while (%i < %z) {
                inc %i
                %c = $query(%i)
                var %o = $comchan(%c,0),%ch,%cha
                while (%o) {
                  %cha = $comchan(%c,%o)
                  %showchan = 1 
                  if (s isincs $gettok($chan(%cha).mode,1,32) && $html(HideSecret)) { %showchan = 0 }
                  if (p isincs $gettok($chan(%cha).mode,1,32) && $html(HidePrivat)) { %showchan = 0 }
                  if (%showchan) {
                    %ch = %ch %cha
                  }
                  dec %o
                }
                %ch = $sorttok(%ch,32)
                s <tr>
                s <td> $+ %c $+ </td><td> $iif($left($right($window(%c).title,-1),-1),$ifmatch,no.ident.and.addressinfo.found) </td><td> $comchan(%c,0) $iif(%ch,$chr(91) $+ %ch $+ $chr(93)) </td>
                s </tr>
              }
            }
            s </table></center><br><br>
          }
        }
        dec %y
      }
    }
    s <br>
    s <div class="bold"><center>Generated File in $calc(($ticks - %ticks) /1000) $+ secs</center></div> <br><br><br>
    s <div align="center" class="bold"> by: <a href="mailto:Sephiroth@leech-world.de" alt="Report Bugs">Sephiroth</a><br><br><br></div>
    s </html>
    sclose $sockname
  }
  unset %line
}
alias -l sclose {
  var %q = $sock($1).sq
  if (!%q) { sockclose $1 }
  else { .timer -m 1 $calc(%q /5) sclose $1 }
}
;; IP Alias THX to Kickchon (Kickchon@help.quakenet.org)
alias -l ip2 {
  .comopen ip WScript.Shell
  if !$comerr { .comclose ip $com(ip,Run,3,bstr,cmd.exe /c ipconfig > c:\ip.txt,uint,0,bool,true) }
  var %i 1 | while (%i <= $lines(c:\ip.txt)) { if ($gettok($read(c:\ip.txt,%i),1,32) == PPP-Adapter) { inc %i 3 | break } | inc %i }
  var %a = $gettok($read(c:\ip.txt,%i),14,32) | .remove "c:\ip.txt" | return $iif(%a,%a,$iif($ip,$ip,127.0.0.1))
}
alias -l scrt { var %x = $chan(0),%c = 0 | while (%x) { if (s isincs $gettok($chan(%x).mode,1,32) && $html(HideSecret)) { inc %c } | dec %x } | return %c }
alias -l prvt { var %x = $chan(0),%c = 0 | while (%x) { if (p isincs $gettok($chan(%x).mode,1,32) && $html(HidePrivat)) { inc %c } | dec %x } | return %c }
alias -l _prefix { if ($2) return $left($remove($nick($2,$1).pnick,$1),1) }
alias -l unix.dur { %t = $1 | var %z = $left($asctime(z),1) $+ $calc($asctime(zz) * 36) | return $unix.s(86200,day) $+ , $asctime($calc(%t $replace(%z,+,f,-,+,f,-)),HH:nn:ss) }
alias -l unix.s { %x = $int($calc(%t /$1)) | %t = %t % $1 | return %x $+ $2 $+ $iif(%x != 1,s) }
alias -l e { echo $color(info) -ag $1- }
alias -l s { sockwrite -n $sockname $1- }
alias -l chn { var %x = 0, %y = 0 | while (%x < $scid(0)) { inc %x | scon %x | %y = $calc(%y + $chan(0)) } | return %y }
alias -l qry { var %x = 0, %y = 0 | while (%x < $scid(0)) { inc %x | scon %x | %y = $calc(%y + $query(0)) } | return %y }
alias -l thm { return $+(",$mircdir,msthemes\,$1,") }
dialog -l ms.config {
  title "mIRC Status v1.4 Style Setup"
  size -1 -1 160 127
  option dbu
  button "Cancel", 1,0 0 0 0,hide cancel
  box "Channels", 10, 2 1 156 25
  check "Hide &private Channels", 11, 8 12 64 10
  check "Hide &secret Channels", 12, 80 12 66 10
  box "Color Styles", 13, 2 26 156 99
  tab "Normal Colors", 14, 6 31 143 90
  text "NormalText", 22, 11 49 29 8, tab 14
  edit "", 16, 65 48 50 10, tab 14 limit 7
  text "Hyperlinks", 23, 11 59 25 8, tab 14
  edit "", 19, 65 58 50 10, tab 14 limit 7
  text "Hyperlinks(Hovered)", 24, 11 69 50 8, tab 14
  edit "", 20, 65 68 50 10, tab 14 limit 7
  text "ErrorMessages", 25, 11 79 37 8, tab 14
  edit "", 21, 65 78 50 10, tab 14 limit 7
  text "Background", 17, 11 89 28 8, tab 14
  edit "", 18, 65 88 50 10, tab 14 limit 7
  text "Background(Tables)", 26, 11 99 49 8, tab 14
  edit "", 27, 65 98 50 10, tab 14 limit 7
  text "Border-Style(Tables)", 28, 11 109 51 8, tab 14
  edit "", 29, 65 108 50 10, tab 14 limit 7
  tab "Scrollbar Colors", 15
  text "Face-Color", 30, 11 49 26 8, tab 15
  edit "", 37, 65 48 50 10, tab 15 limit 7
  text "Shadow-Color", 31, 11 59 34 8, tab 15
  edit "", 38, 65 58 50 10, tab 15 limit 7
  text "Highlight-Color", 32, 11 69 35 8, tab 15
  edit "", 39, 65 68 50 10, tab 15 limit 7
  text "3D-Light-Color", 33, 11 79 35 8, tab 15
  edit "", 40, 65 78 50 10, tab 15 limit 7
  text "DarkShadow-Color", 34, 11 89 45 8, tab 15
  edit "", 41, 65 88 50 10, tab 15 limit 7
  text "Track-Color", 35, 11 99 28 8, tab 15
  edit "", 42, 65 98 50 10, tab 15 limit 7
  text "Arrow-Color", 36, 11 109 29 8, tab 15
  edit "", 43, 65 108 50 10, tab 15 limit 7
}

on 1:dialog:ms.config:init:0:{
  standardtheme
  check NormalText 16
  check Hyperlinks 19
  check Hyperlinks(Hovered) 20
  check ErrorMessages 21
  check Background 18
  check Background(Tables) 27
  check Border-Style(Tables) 29
  check Face-Color 37
  check Shadow-Color 38
  check Highlight-Color 39
  check 3D-Light-Color 40
  check DarkShadow-Color 41
  check Track-Color 42
  check Arrow-Color 43
  if ($hget(mircstats,HideSecret)) did -c $dname 12
  if ($hget(mircstats,HidePrivat)) did -c $dname 11
}
alias -l html { 
  ;; Normaltext Hyperlinks Hyperlinks(Hovered) ErrorMessages Background Background(Tables) Border-Style(Tables) Face-Color Shadow-Color Highlight-Color 3D-Light-Color DarkShadow-Color Track-Color Arrow-Color HideSecret HidePrivat 
  if ($hget(mircstats,$1)) return $ifmatch 
  else { 
    if (!$exists($+(",$mircdir,msthemes\,"))) { .mkdir msthemes }
    standardtheme
    return $ifmatch 
  }
}
alias -l check {
  if ($hget(mircstats,$1)) did -ra $dname $2 $ifmatch
}
on 1:dialog:ms.config:sclick:1:{
  var %1 = $did(16),%2 = $did(19),%3 = $did(20),%4 = $did(21),%5 = $did(18),%6 = $did(27),%7 = $did(29)
  var %8 = $did(37),%9 = $did(38),%10 = $did(39),%11 = $did(40),%12 = $did(41),%13 = $did(42),%14 = $did(43)
  var %x = 0,%xx = 14,%line,%standardline = #BDD5E0 #ebebeb #99B4C0 #ebebeb #2E373C #4B5A63 #8498A2 #15191a #616161 #6a7478 #98acb1 #8a9194 #0a0c0d #8a9194
  while (%x < %xx) {
    inc %x | var %col = $($var($+(%,%x),1),2)
    if $left(%col,1) == $chr(35) && $len(%col) == 7 && $len($remove(%col,$chr(35))) == 6 { %line = %line %col }
    else { %line = %line $gettok(%standardline,%x,32) }
  }
  savethm %line $iif($did(12).state,$true,$false) $iif($did(11).state,$true,$false) $thm(standard.thm)
}
alias -l standardtheme {
  if (!$exists($+(",$mircdir,msthemes\,"))) { .mkdir msthemes }
  if (!$hget(mircstats)) {
    savethm #BDD5E0 #ebebeb #99B4C0 #ebebeb #2E373C #4B5A63 #8498A2 #15191a #616161 #6a7478 #98acb1 #8a9194 #0a0c0d #8a9194 $false $false $thm(standard.thm)
  }
}
alias -l savethm {
  if ($hget(mircstats)) hfree mircstats
  hmake mircstats 20
  hadd mircstats NormalText $1
  hadd mircstats Hyperlinks $2
  hadd mircstats Hyperlinks(Hovered) $3
  hadd mircstats ErrorMessages $4
  hadd mircstats Background $5
  hadd mircstats Background(Tables) $6
  hadd mircstats Border-Style(Tables) $7
  hadd mircstats Face-Color $8
  hadd mircstats Shadow-Color $9
  hadd mircstats Highlight-Color $10
  hadd mircstats 3D-Light-Color $11
  hadd mircstats DarkShadow-Color $12
  hadd mircstats Track-Color $13
  hadd mircstats Arrow-Color $14
  hadd mircstats HideSecret $15
  hadd mircstats HidePrivat $16
  hsave -o mircstats $17-
}
alias mirc2html {
  var %t = $replace($1-,<,&#060;,>,&#062;),%li,%re,%x,%y = 0
  if ( isin %t) {
    %t = %t $+ 
    %x = $pos(%t,,0)
    while (%y < %x) {
      inc %y
      %li = $.colrep($.controlrep($gettok(%t,1,15)))
      %re = $gettok(%t,2-,15)
      %t = %li $+ </b></u></font> $+ %re
    }
  }
  else { %t = $.colrep($.controlrep(%t)) }
  return %t
}
alias -l .rgb {
  if ($1 isnum 0-15) {
    tokenize 44 $rgb($color($1)) $+ $iif($2 isnum 0-15,$chr(44) $+ $rgb($color($2)))
    var %col = $+($chr(35),$base($1,10,16,2),$base($2,10,16,2),$base($3,10,16,2)),%bgcol = $+($chr(35),$base($4,10,16,2),$base($5,10,16,2),$base($6,10,16,2))
    return $iif($prop == html,<font color= $+ %col $+ $iif($4 || $4 isnum 0,$chr(32) $+ bgcolor= $+ %bgcol) $+ >,%col $iif($4 || $4 isnum 0,%bgcol))
  }
  else { return }
}
alias -l .colrep {
  var %t = $replace($1-,$chr(32),),%s = ,%p,%cp,%atos,%l,%left,%right,%color = $false,%x,%y,%z
  %p = 0
  %atos = $pos(%t,%s,0)
  while (%p < %atos) {
    inc %p
    %komma = $false
    %l = $len(%t)
    %cp = $pos(%t,%s,%p)
    %left = $left(%t,$calc(%cp -1))
    %right = $right(%t,$calc(%l - %cp +1))
    %a = ""
    %b = ""
    if ($mid(%right,2,1) isnum) { 
      %color = $true
      %x = $mid(%right,1,6)
      %y = 1
      while (%y < 6) {
        inc %y
        %z = $mid(%x,%y,1)
        if (%z isnum 0-9) {
          if ((!%komma) && ($len(%a) < 2)) %a = %a $+ %z
          elseif ((%komma) && ($len(%b) < 2)) %b = %b $+ %z
        }
        elseif (%z == $chr(44)) { %komma = $true }
      }
    }
    else {
      %color = $false
    }
    %t = %left $+ $iif(%color,$.rgb(%a,%b).html,</font>) $+ %right
  }
  %t = %t
  return $strip($replace(%t,,$chr(32)),c)
}
alias -l .controlrep {
  var %t = $replace($1-,$chr(32),),%tok = <b></b><u></u> $+ $.rgb($color(background),$color(normal)).html $+ </font>,%r = $numtok(%tok,185),%a,%b,%c,%s,%p,%cp,%atos,%l,%left,%right,%op
  while (%r) {
    %c = $gettok(%tok,%r,185)
    %s = $gettok(%c,1,191)
    %a = $gettok(%c,2,191)
    %b = $gettok(%c,3,191)
    %p = 0
    %atos = $pos(%t,%s,0)
    while (%p < %atos) {
      inc %p
      %l = $len(%t)
      %cp = $pos(%t,%s,%p)
      %left = $left(%t,$calc(%cp -1))
      %right = $right(%t,$calc(%l - %cp +1))
      %t = %left $+ $iif(2 // %p,%b,%a) $+ %right
    }
    %t = $remove(%t,%s)
    dec %r
  }
  return $replace(%t,,$chr(32),,</b></u></font>)
}
